//
//  DataLoader.h
//  MobileDaxhotel
//
//  Created by Raphael Schweikert on 29.06.08.
//  Copyright 2008 sabberworm. All rights reserved.
//

#import <UIKit/UIKit.h>
#import "NSString+AdvancedSubstring.h"
#import "NSObject+Invocations.h"
#import "DataController.h"
#import "NSString+EntityDecoding.h"
#import "UIImage+INResizeImageAllocator.h"

@class LoaderWindowController;

@interface DataLoader : NSThread {
    DataController *dataController;
    LoaderWindowController *loaderWindowController;
    NSDictionary *fetchProperties;
    NSURL *baseUrl;
    DAXHOTEL_DB_STATUS dbStatus;
}

- (DataLoader *)initWithData:data controller:controller status:(DAXHOTEL_DB_STATUS)status;
- (BOOL)loadSkeleton;
- (BOOL)loadContents;
- (UIImage *)resizeOverviewImage:(UIImage *) overviewImage;
- (NSString *)fetchPropertyForKey:(NSString *)propertyName;
- (void)displayLoadingText:(NSString *)text image:(UIImage *)image isCenter:(BOOL)isCenter synchronized:(BOOL) synchronized;
- (LoaderWindowController *) loaderWindowControllerForMainThreadSynchronized:(BOOL) synchronized;
- (LoaderWindowController *) loaderWindowControllerForMainThread;

@end
